import numpy as np
from scipy import signal

from server.sl8 import FileBase


def design_filters(s_rate):
    filters = {}
    output = signal.butter(N=5, Wn=np.array([45, 55]), btype='bandstop', analog=False, output='ba', fs=s_rate)
    filters['notch1'] = [output[0], output[1]]  # b, a
    output = signal.butter(N=5, Wn=np.array([95, 105]), btype='bandstop', analog=False, output='ba', fs=s_rate)
    filters['notch2'] = [output[0], output[1]]  # b, a
    output = signal.butter(N=5, Wn=np.array([0.53, 32]), btype='bandpass', analog=False, output='ba', fs=s_rate)
    filters['bandpass'] = [output[0], output[1]]  # b, a
    return filters


# def iec_maker(data, id_, sps, gain, leadoff):
def iec_maker(data, id_, sps):
    identifier = str(id_)
    sps = int(sps)
    file_base = FileBase(subject_id=0, protocol_name='', task_name=identifier, fatigue=0,
                         hungriness=0, sequence=[], project='1', description='')

    file_base.set_brain_data(data, int(len(data)), int(len(data[0])), sps)  # All fields are numeric.
    file_base.set_device_data('s', '12', '12', 's')  # Use standard patterns like what you can see on the server.
    file_base.set_sensor('s')  # Use string name of sensor.
    file_base.set_extra_signal(data, int(3), int(len(data[0])), sps)  # All fields are numeric.
    file_base.set_output_data(data, int(len(data)), int(len(data[0])), sps)  # All fields are numeric.
    file_base.set_reaction_data([0], [0], [0])
    # file_base.set_gain(gain)
    # file_base.set_leadoff(leadoff)
    file_base.save('blink_removed_iec_files/', filename=id_)
    # file_base.save('iec_files/', filename=id_)
    return 'success'
